#include "stdafx.h"
#include "dyndata.h"



BOOL MyEnumObjectCounters(DWORD /*dwItemData*/, CDynDataObject& /*object*/, const CString& sRegistryName, 
                          const CString& sCommonName, const CString& sDescription, BOOL bDifferentiate)
{
  TRACE(_T("Common Name:%s, Registry Name:%s, Description.:%s, Difference:%d\n"), sCommonName.operator LPCTSTR(), sRegistryName.operator LPCTSTR(), sDescription.operator LPCTSTR(), bDifferentiate);
  
  //To get rid of level 4 warnings
  sCommonName;
  sDescription;
  bDifferentiate;
  sRegistryName;

  //Allow the iteration to continue
  return TRUE;
}

BOOL MyEnumObjects(DWORD /*dwItemData*/, CDynDataObject& object)
{
  TRACE(_T("Found the performance object:%s, Description: %s\n"), object.GetName().operator LPCTSTR(), object.GetDescription().operator LPCTSTR());

  //Enumerate all the counters which "object" contains
  object.EnumCounters(MyEnumObjectCounters);

  TRACE(_T("\n\n"));
  
  //Allow the iteration to continue
  return TRUE;
}


void _tmain(int argc, TCHAR* argv[])
{
	//initialize MFC (required since we are a console app)
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
  {
    _tprintf(_T("Failed to initialize MFC\n"));
		return;
  }

  //Test out the enumerator classes
  CDynDataEnumerator DataEnumerator;
  DataEnumerator.EnumObjects(MyEnumObjects);

  //Test out the object class
  CDynDataObject DataObject(_T("KERNEL"), static_cast<LPCTSTR>(NULL));
  TRACE(_T("Enumerating the counters for the KERNEL object\n"));
  DataObject.EnumCounters(MyEnumObjectCounters);
  TRACE(_T("Description was %s\n"), DataObject.GetDescription().operator LPCTSTR());


  //Test up the counter class
  if ((argc != 3) && (argc != 4))
  {
    _tprintf(_T("Usage: DynData CounterName ObjectName [ComputerName]\n"));
    _tprintf(_T("where CounterName is a HKEY_DYN_DATA counter\n"));
    _tprintf(_T("to monitor such as KERNEL\\CPUUsage\n"));
  }
  else
  {
    CDynDataCounter dd;
    BOOL bSuccess;
    if (argc == 3)
      bSuccess = dd.Start(argv[1], argv[2]);
    else
      bSuccess = dd.Start(argv[1], argv[2], argv[3]);
    
    if (bSuccess)
    {
      DWORD dwData;
      while (1)
      {
        if (dd.Collect(dwData))
        {
          _tprintf(_T("%s: %d\n"), dd.GetCounterName().operator LPCTSTR(), dwData);
          TRACE(_T("%s: %d\n"), dd.GetCounterName().operator LPCTSTR(), dwData);
        }
        else
          _tprintf(_T("Error querying data, LastError:%d\n"), GetLastError());
        Sleep(1000);

        if (_kbhit())
          break;
      }
    }
    else
      _tprintf(_T("Failed to start collecting the data\n"));

    dd.Stop();
  }
}